/* deque.h - header for deque package */
#ifndef DEQUE_H
#define DEQUE_H
#include "local.h"
#include "pointer.h"
#define DQ_NODE struct dq_node
DQ_NODE
	{
	DQ_NODE *left;
	DQ_NODE *right;
	/* ... */
	};

#define DQ_P(p) 		PNNC(p, DQ_NODE *)
#define DQ_PP(p)		PNNC(p, DQ_NODE **)

/* CJS added balancing right parens to each function lines 19-25 */

void dq_close  PARMS( (DQ_NODE **pdq ));
DQ_NODE *dq_detach  PARMS( (DQ_NODE *dq, DQ_NODE *d ));
DQ_NODE *dq_find  PARMS( (DQ_NODE *dq, DQ_NODE *d, int (*cmpfn)() ));
void dq_insert	PARMS( (DQ_NODE *dq, DQ_NODE *d, int (*cmpfn)() ));
void dq_open  PARMS( (DQ_NODE **pdq ));
DQ_NODE *dq_pop  PARMS( (DQ_NODE *dq ));
void dq_r_insert  PARMS( (DQ_NODE *d, DQ_NODE *p ));

/* CJS added declaration of dq_first() 10/29/86 */
DQ_NODE *dq_first();

/* pure macros */
#define DQ_APPEND(dq, d)    DQ_R_INSERT(d, (dq)->left)
#define DQ_IS_EMPTY(dq) 	(PNN(dq)->right == PNN(dq))
#define DQ_L_DETACH(dq, d)	DQ_DETACH(PNN(dq), PNN(d)->left)
#define DQ_L_INSERT(d, p)   DQ_R_INSERT((d), (p)->left)
#define DQ_PRED(dq, d) \
	(DQ_P(d)->left == PNN(dq)?(dq->left):(DQ_P(d)->left))
#define DQ_PUSH(dq, d)	    DQ_R_INSERT((d), (dq))
#define DQ_R_DETACH(dq, d)		DQ_DETACH(dq, PNN(d)->right)
#define DQ_SUCC(dq, d) \
	(DQ_P(d)->right == PNN(dq)?(dq->right):(DQ_P(d)->right))
#define EACH_DQ(dq, d, t) \
	for (d = (t *)(dq)->right; (DQ_NODE *)(d) != dq; d = (d)->right)
/* function-interface macros */
#define DQ_CLOSE(pdq)	    dq_close(PNN(pdq))
#define DQ_DETACH(dq, d)    dq_detach(DQ_P(dq), DQ_P(d))
#define DQ_FIND(dq, d, fn)  dq_find(PNN(dq), DQ_P(d), fn)
#define DQ_FIRST(dq)		dq_first(PNN(dq))
#define DQ_INSERT(dq, d, fn)  dq_insert(PNN(dq), DQ_P(d), fn)
#define DQ_OPEN(pdq)	    dq_open(PNN(pdq))
#define DQ_POP(dq)	    dq_pop(PNN(dq))
#define DQ_R_INSERT(d, p)   dq_r_insert(DQ_P(d), DQ_P(p))
#endif
